diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/ipv4-interface.cc ns-3.45/src/internet/model/ipv4-interface.cc
--- ns-3.44/src/internet/model/ipv4-interface.cc	2025-03-09 16:55:49.395371200 -0700
+++ ns-3.45/src/internet/model/ipv4-interface.cc	2025-06-01 20:34:45.323701100 -0700
@@ -31,16 +31,20 @@
 TypeId
 Ipv4Interface::GetTypeId()
 {
-    static TypeId tid = TypeId("ns3::Ipv4Interface")
-                            .SetParent<Object>()
-                            .SetGroupName("Internet")
-                            .AddAttribute("ArpCache",
-                                          "The arp cache for this ipv4 interface",
-                                          PointerValue(nullptr),
-                                          MakePointerAccessor(&Ipv4Interface::SetArpCache,
-                                                              &Ipv4Interface::GetArpCache),
-                                          MakePointerChecker<ArpCache>());
-    ;
+    static TypeId tid =
+        TypeId("ns3::Ipv4Interface")
+            .SetParent<Object>()
+            .SetGroupName("Internet")
+            .AddAttribute(
+                "ArpCache",
+                "The arp cache for this ipv4 interface",
+                PointerValue(nullptr),
+                MakePointerAccessor(&Ipv4Interface::SetArpCache, &Ipv4Interface::GetArpCache),
+                MakePointerChecker<ArpCache>())
+            .AddTraceSource("InterfaceStatus",
+                            "Interface has been set up or down.",
+                            MakeTraceSourceAccessor(&Ipv4Interface::m_interfaceStatus),
+                            "ns3::Ipv4Address::TracedCallback");
     return tid;
 }
 
@@ -175,6 +179,11 @@
 {
     NS_LOG_FUNCTION(this);
     m_ifup = true;
+
+    Ptr<Ipv4> ip = m_node->GetObject<Ipv4>();
+    NS_ASSERT_MSG(ip, "IPv4 not installed on node.");
+    auto ifIndex = ip->GetInterfaceForDevice(m_device);
+    m_interfaceStatus(m_ifup, ifIndex);
 }
 
 void
@@ -182,6 +191,11 @@
 {
     NS_LOG_FUNCTION(this);
     m_ifup = false;
+
+    Ptr<Ipv4> ip = m_node->GetObject<Ipv4>();
+    NS_ASSERT_MSG(ip, "IPv4 not installed on node.");
+    auto ifIndex = ip->GetInterfaceForDevice(m_device);
+    m_interfaceStatus(m_ifup, ifIndex);
 }
 
 bool
@@ -239,8 +253,7 @@
     }
     if (m_device->NeedsArp())
     {
-        NS_LOG_LOGIC("Needs ARP"
-                     << " " << dest);
+        NS_LOG_LOGIC("Needs ARP " << dest);
         Ptr<ArpL3Protocol> arp = m_node->GetObject<ArpL3Protocol>();
         Address hardwareDestination;
         bool found = false;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/ipv4-interface.h ns-3.45/src/internet/model/ipv4-interface.h
--- ns-3.44/src/internet/model/ipv4-interface.h	2025-03-09 16:55:49.395371200 -0700
+++ ns-3.45/src/internet/model/ipv4-interface.h	2025-06-01 20:34:45.323701100 -0700
@@ -12,6 +12,7 @@
 
 #include "ns3/object.h"
 #include "ns3/ptr.h"
+#include "ns3/traced-callback.h"
 
 #include <list>
 
@@ -238,6 +239,12 @@
         m_removeAddressCallback; //!< remove address callback
     Callback<void, Ptr<Ipv4Interface>, Ipv4InterfaceAddress>
         m_addAddressCallback; //!< add address callback
+
+    /**
+     * The trace fired when the interface state changes.
+     * Includes state (true if interface is up) and the interface index.
+     */
+    ns3::TracedCallback<bool, int32_t> m_interfaceStatus;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/ipv6-interface.cc ns-3.45/src/internet/model/ipv6-interface.cc
--- ns-3.44/src/internet/model/ipv6-interface.cc	2025-03-09 16:55:49.399371100 -0700
+++ ns-3.45/src/internet/model/ipv6-interface.cc	2025-06-01 20:34:45.325701200 -0700
@@ -33,7 +33,14 @@
 TypeId
 Ipv6Interface::GetTypeId()
 {
-    static TypeId tid = TypeId("ns3::Ipv6Interface").SetParent<Object>().SetGroupName("Internet");
+    static TypeId tid =
+        TypeId("ns3::Ipv6Interface")
+            .SetParent<Object>()
+            .SetGroupName("Internet")
+            .AddTraceSource("InterfaceStatus",
+                            "Interface has been set up or down.",
+                            MakeTraceSourceAccessor(&Ipv6Interface::m_interfaceStatus),
+                            "ns3::Ipv6Address::TracedCallback");
     return tid;
 }
 
@@ -170,6 +177,11 @@
     }
     DoSetup();
     m_ifup = true;
+
+    Ptr<Ipv6> ip = m_node->GetObject<Ipv6>();
+    NS_ASSERT_MSG(ip, "IPv6 not installed on node.");
+    auto ifIndex = ip->GetInterfaceForDevice(m_device);
+    m_interfaceStatus(m_ifup, ifIndex);
 }
 
 void
@@ -179,6 +191,11 @@
     m_ifup = false;
     m_addresses.clear();
     m_ndCache->Flush();
+
+    Ptr<Ipv6> ip = m_node->GetObject<Ipv6>();
+    NS_ASSERT_MSG(ip, "IPv6 not installed on node.");
+    auto ifIndex = ip->GetInterfaceForDevice(m_device);
+    m_interfaceStatus(m_ifup, ifIndex);
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/ipv6-interface.h ns-3.45/src/internet/model/ipv6-interface.h
--- ns-3.44/src/internet/model/ipv6-interface.h	2025-03-09 16:55:49.399371100 -0700
+++ ns-3.45/src/internet/model/ipv6-interface.h	2025-06-01 20:34:45.325701200 -0700
@@ -13,6 +13,7 @@
 
 #include "ns3/object.h"
 #include "ns3/ptr.h"
+#include "ns3/traced-callback.h"
 
 #include <list>
 
@@ -386,6 +387,12 @@
 
     Callback<void, Ptr<Ipv6Interface>, Ipv6InterfaceAddress>
         m_addAddressCallback; //!< add address callback
+
+    /**
+     * The trace fired when the interface state changes.
+     * Includes state (true if interface is up) and the interface index.
+     */
+    ns3::TracedCallback<bool, int32_t> m_interfaceStatus;
 };
 
 } /* namespace ns3 */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/rtt-estimator.cc ns-3.45/src/internet/model/rtt-estimator.cc
--- ns-3.44/src/internet/model/rtt-estimator.cc	2025-03-09 16:55:49.403371000 -0700
+++ ns-3.45/src/internet/model/rtt-estimator.cc	2025-06-01 20:34:45.328701300 -0700
@@ -87,12 +87,6 @@
     NS_LOG_FUNCTION(this);
 }
 
-TypeId
-RttEstimator::GetInstanceTypeId() const
-{
-    return GetTypeId();
-}
-
 void
 RttEstimator::Reset()
 {
@@ -149,12 +143,6 @@
     NS_LOG_FUNCTION(this);
 }
 
-TypeId
-RttMeanDeviation::GetInstanceTypeId() const
-{
-    return GetTypeId();
-}
-
 uint32_t
 RttMeanDeviation::CheckForReciprocalPowerOfTwo(double val) const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/rtt-estimator.h ns-3.45/src/internet/model/rtt-estimator.h
--- ns-3.44/src/internet/model/rtt-estimator.h	2025-03-09 16:55:49.403371000 -0700
+++ ns-3.45/src/internet/model/rtt-estimator.h	2025-06-01 20:34:45.328701300 -0700
@@ -46,8 +46,6 @@
 
     ~RttEstimator() override;
 
-    TypeId GetInstanceTypeId() const override;
-
     /**
      * @brief Add a new measurement to the estimator. Pure virtual function.
      * @param t the new RTT measure.
@@ -126,8 +124,6 @@
      */
     RttMeanDeviation(const RttMeanDeviation& r);
 
-    TypeId GetInstanceTypeId() const override;
-
     /**
      * @brief Add a new measurement to the estimator.
      * @param measure the new RTT measure.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/tcp-bbr.cc ns-3.45/src/internet/model/tcp-bbr.cc
--- ns-3.44/src/internet/model/tcp-bbr.cc	2025-03-09 16:55:49.403371000 -0700
+++ ns-3.45/src/internet/model/tcp-bbr.cc	2025-06-01 20:34:45.328701300 -0700
@@ -119,7 +119,6 @@
       m_isInitialized(sock.m_isInitialized),
       m_uv(sock.m_uv),
       m_delivered(sock.m_delivered),
-      m_appLimited(sock.m_appLimited),
       m_extraAckedGain(sock.m_extraAckedGain),
       m_extraAckedWinRtt(sock.m_extraAckedWinRtt),
       m_extraAckedWinRttLength(sock.m_extraAckedWinRttLength),
@@ -132,6 +131,12 @@
     NS_LOG_FUNCTION(this);
 }
 
+void
+TcpBbr::SetRateOps(Ptr<TcpRateOps> rateOps)
+{
+    m_rateOps = rateOps;
+}
+
 const char* const TcpBbr::BbrModeName[BBR_PROBE_RTT + 1] = {
     "BBR_STARTUP",
     "BBR_DRAIN",
@@ -415,8 +420,7 @@
 {
     NS_LOG_FUNCTION(this << tcb);
 
-    uint32_t totalBytes = m_delivered + tcb->m_bytesInFlight.Get();
-    m_appLimited = (totalBytes > 0 ? totalBytes : 1);
+    m_rateOps->SetAppLimited(tcb->m_bytesInFlight.Get());
 
     if (m_probeRttDoneStamp.IsZero() && tcb->m_bytesInFlight <= m_minPipeCwnd)
     {
@@ -763,7 +767,8 @@
         m_packetConservation = false;
         RestoreCwnd(tcb);
     }
-    else if (event == TcpSocketState::CA_EVENT_TX_START && m_appLimited)
+    else if (event == TcpSocketState::CA_EVENT_TX_START &&
+             m_rateOps->GetConnectionRate().m_appLimited)
     {
         NS_LOG_DEBUG("CwndEvent triggered to CA_EVENT_TX_START :: " << event);
         m_idleRestart = true;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/tcp-bbr.h ns-3.45/src/internet/model/tcp-bbr.h
--- ns-3.44/src/internet/model/tcp-bbr.h	2025-03-09 16:55:49.403371000 -0700
+++ ns-3.45/src/internet/model/tcp-bbr.h	2025-06-01 20:34:45.328701300 -0700
@@ -100,6 +100,7 @@
                             const TcpSocketState::TcpCongState_t newState) override;
     void CwndEvent(Ptr<TcpSocketState> tcb, const TcpSocketState::TcpCAEvent_t event) override;
     uint32_t GetSsThresh(Ptr<const TcpSocketState> tcb, uint32_t bytesInFlight) override;
+    void SetRateOps(Ptr<TcpRateOps> rateOps) override;
     Ptr<TcpCongestionOps> Fork() override;
 
   public:
@@ -375,9 +376,8 @@
     Time m_minRttStamp; //!< The wall clock time at which the current BBR.RTProp sample was obtained
     bool m_isInitialized{false}; //!< Set to true after first time initialization variables
     Ptr<UniformRandomVariable> m_uv{nullptr}; //!< Uniform Random Variable
-    uint64_t m_delivered{0}; //!< The total amount of data in bytes delivered so far
-    uint32_t m_appLimited{
-        0}; //!< The index of the last transmitted packet marked as application-limited
+    uint64_t m_delivered{0};              //!< The total amount of data in bytes delivered so far
+    Ptr<TcpRateOps> m_rateOps;            //!< Rate operations
     uint32_t m_extraAckedGain{1};         //!< Gain factor for adding extra ack to cwnd
     uint32_t m_extraAcked[2]{0, 0};       //!< Maximum excess data acked in epoch
     uint32_t m_extraAckedWinRtt{0};       //!< Age of extra acked in rtt
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/tcp-congestion-ops.h ns-3.45/src/internet/model/tcp-congestion-ops.h
--- ns-3.44/src/internet/model/tcp-congestion-ops.h	2025-03-09 16:55:49.407371300 -0700
+++ ns-3.45/src/internet/model/tcp-congestion-ops.h	2025-06-01 20:34:45.328701300 -0700
@@ -73,6 +73,15 @@
     }
 
     /**
+     * @brief Set rate operation required by the congestion control algorithm
+     *
+     * @param rateOps a pointer to the rate operation object used to manage rate control
+     */
+    virtual void SetRateOps(Ptr<TcpRateOps> rateOps [[maybe_unused]])
+    {
+    }
+
+    /**
      * @brief Get the slow start threshold after a loss event
      *
      * Is guaranteed that the congestion control state (\p TcpAckState_t) is
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/tcp-option.cc ns-3.45/src/internet/model/tcp-option.cc
--- ns-3.44/src/internet/model/tcp-option.cc	2025-03-09 16:55:49.407371300 -0700
+++ ns-3.45/src/internet/model/tcp-option.cc	2025-06-01 20:34:45.329701200 -0700
@@ -41,12 +41,6 @@
     return tid;
 }
 
-TypeId
-TcpOption::GetInstanceTypeId() const
-{
-    return GetTypeId();
-}
-
 Ptr<TcpOption>
 TcpOption::CreateOption(uint8_t kind)
 {
@@ -122,12 +116,6 @@
     return tid;
 }
 
-TypeId
-TcpOptionUnknown::GetInstanceTypeId() const
-{
-    return GetTypeId();
-}
-
 void
 TcpOptionUnknown::Print(std::ostream& os) const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/tcp-option.h ns-3.45/src/internet/model/tcp-option.h
--- ns-3.44/src/internet/model/tcp-option.h	2025-03-09 16:55:49.407371300 -0700
+++ ns-3.45/src/internet/model/tcp-option.h	2025-06-01 20:34:45.329701200 -0700
@@ -35,8 +35,6 @@
      */
     static TypeId GetTypeId();
 
-    TypeId GetInstanceTypeId() const override;
-
     /**
      * The option Kind, as defined in the respective RFCs.
      */
@@ -120,7 +118,6 @@
      * @return the object TypeId
      */
     static TypeId GetTypeId();
-    TypeId GetInstanceTypeId() const override;
 
     void Print(std::ostream& os) const override;
     void Serialize(Buffer::Iterator start) const override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/tcp-option-rfc793.cc ns-3.45/src/internet/model/tcp-option-rfc793.cc
--- ns-3.44/src/internet/model/tcp-option-rfc793.cc	2025-03-09 16:55:49.407371300 -0700
+++ ns-3.45/src/internet/model/tcp-option-rfc793.cc	2025-06-01 20:34:45.329701200 -0700
@@ -38,12 +38,6 @@
     return tid;
 }
 
-TypeId
-TcpOptionEnd::GetInstanceTypeId() const
-{
-    return GetTypeId();
-}
-
 void
 TcpOptionEnd::Print(std::ostream& os) const
 {
@@ -108,12 +102,6 @@
     return tid;
 }
 
-TypeId
-TcpOptionNOP::GetInstanceTypeId() const
-{
-    return GetTypeId();
-}
-
 void
 TcpOptionNOP::Print(std::ostream& os) const
 {
@@ -178,12 +166,6 @@
     return tid;
 }
 
-TypeId
-TcpOptionMSS::GetInstanceTypeId() const
-{
-    return GetTypeId();
-}
-
 void
 TcpOptionMSS::Print(std::ostream& os) const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/tcp-option-rfc793.h ns-3.45/src/internet/model/tcp-option-rfc793.h
--- ns-3.44/src/internet/model/tcp-option-rfc793.h	2025-03-09 16:55:49.407371300 -0700
+++ ns-3.45/src/internet/model/tcp-option-rfc793.h	2025-06-01 20:34:45.329701200 -0700
@@ -29,7 +29,6 @@
      * @return the object TypeId
      */
     static TypeId GetTypeId();
-    TypeId GetInstanceTypeId() const override;
 
     void Print(std::ostream& os) const override;
     void Serialize(Buffer::Iterator start) const override;
@@ -53,7 +52,6 @@
      * @return the object TypeId
      */
     static TypeId GetTypeId();
-    TypeId GetInstanceTypeId() const override;
 
     void Print(std::ostream& os) const override;
     void Serialize(Buffer::Iterator start) const override;
@@ -77,7 +75,6 @@
      * @return the object TypeId
      */
     static TypeId GetTypeId();
-    TypeId GetInstanceTypeId() const override;
 
     void Print(std::ostream& os) const override;
     void Serialize(Buffer::Iterator start) const override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/tcp-option-sack.cc ns-3.45/src/internet/model/tcp-option-sack.cc
--- ns-3.44/src/internet/model/tcp-option-sack.cc	2025-03-09 16:55:49.407371300 -0700
+++ ns-3.45/src/internet/model/tcp-option-sack.cc	2025-06-01 20:34:45.329701200 -0700
@@ -41,12 +41,6 @@
     return tid;
 }
 
-TypeId
-TcpOptionSack::GetInstanceTypeId() const
-{
-    return GetTypeId();
-}
-
 void
 TcpOptionSack::Print(std::ostream& os) const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/tcp-option-sack.h ns-3.45/src/internet/model/tcp-option-sack.h
--- ns-3.44/src/internet/model/tcp-option-sack.h	2025-03-09 16:55:49.407371300 -0700
+++ ns-3.45/src/internet/model/tcp-option-sack.h	2025-06-01 20:34:45.329701200 -0700
@@ -44,7 +44,6 @@
      * @return the object TypeId
      */
     static TypeId GetTypeId();
-    TypeId GetInstanceTypeId() const override;
 
     typedef std::pair<SequenceNumber32, SequenceNumber32> SackBlock; //!< SACK block definition
     typedef std::list<SackBlock> SackList;                           //!< SACK list definition
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/tcp-option-sack-permitted.cc ns-3.45/src/internet/model/tcp-option-sack-permitted.cc
--- ns-3.44/src/internet/model/tcp-option-sack-permitted.cc	2025-03-09 16:55:49.407371300 -0700
+++ ns-3.45/src/internet/model/tcp-option-sack-permitted.cc	2025-06-01 20:34:45.329701200 -0700
@@ -40,12 +40,6 @@
     return tid;
 }
 
-TypeId
-TcpOptionSackPermitted::GetInstanceTypeId() const
-{
-    return GetTypeId();
-}
-
 void
 TcpOptionSackPermitted::Print(std::ostream& os) const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/tcp-option-sack-permitted.h ns-3.45/src/internet/model/tcp-option-sack-permitted.h
--- ns-3.44/src/internet/model/tcp-option-sack-permitted.h	2025-03-09 16:55:49.407371300 -0700
+++ ns-3.45/src/internet/model/tcp-option-sack-permitted.h	2025-06-01 20:34:45.329701200 -0700
@@ -36,7 +36,6 @@
      * @return the object TypeId
      */
     static TypeId GetTypeId();
-    TypeId GetInstanceTypeId() const override;
 
     TcpOptionSackPermitted();
     ~TcpOptionSackPermitted() override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/tcp-option-ts.cc ns-3.45/src/internet/model/tcp-option-ts.cc
--- ns-3.44/src/internet/model/tcp-option-ts.cc	2025-03-09 16:55:49.407371300 -0700
+++ ns-3.45/src/internet/model/tcp-option-ts.cc	2025-06-01 20:34:45.329701200 -0700
@@ -38,12 +38,6 @@
     return tid;
 }
 
-TypeId
-TcpOptionTS::GetInstanceTypeId() const
-{
-    return GetTypeId();
-}
-
 void
 TcpOptionTS::Print(std::ostream& os) const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/tcp-option-ts.h ns-3.45/src/internet/model/tcp-option-ts.h
--- ns-3.44/src/internet/model/tcp-option-ts.h	2025-03-09 16:55:49.407371300 -0700
+++ ns-3.45/src/internet/model/tcp-option-ts.h	2025-06-01 20:34:45.329701200 -0700
@@ -33,7 +33,6 @@
      * @return the object TypeId
      */
     static TypeId GetTypeId();
-    TypeId GetInstanceTypeId() const override;
 
     void Print(std::ostream& os) const override;
     void Serialize(Buffer::Iterator start) const override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/tcp-option-winscale.cc ns-3.45/src/internet/model/tcp-option-winscale.cc
--- ns-3.44/src/internet/model/tcp-option-winscale.cc	2025-03-09 16:55:49.407371300 -0700
+++ ns-3.45/src/internet/model/tcp-option-winscale.cc	2025-06-01 20:34:45.329701200 -0700
@@ -38,12 +38,6 @@
     return tid;
 }
 
-TypeId
-TcpOptionWinScale::GetInstanceTypeId() const
-{
-    return GetTypeId();
-}
-
 void
 TcpOptionWinScale::Print(std::ostream& os) const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/tcp-option-winscale.h ns-3.45/src/internet/model/tcp-option-winscale.h
--- ns-3.44/src/internet/model/tcp-option-winscale.h	2025-03-09 16:55:49.407371300 -0700
+++ ns-3.45/src/internet/model/tcp-option-winscale.h	2025-06-01 20:34:45.329701200 -0700
@@ -44,7 +44,6 @@
      * @return the object TypeId
      */
     static TypeId GetTypeId();
-    TypeId GetInstanceTypeId() const override;
 
     TcpOptionWinScale();
     ~TcpOptionWinScale() override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/tcp-rate-ops.cc ns-3.45/src/internet/model/tcp-rate-ops.cc
--- ns-3.44/src/internet/model/tcp-rate-ops.cc	2025-03-09 16:55:49.407371300 -0700
+++ ns-3.45/src/internet/model/tcp-rate-ops.cc	2025-06-01 20:34:45.330701400 -0700
@@ -144,8 +144,7 @@
         && in_flight < cWnd                   // We are not limited by CWND.
         && lostOut <= retransOut)             // All lost packets have been retransmitted.
     {
-        m_rate.m_appLimited = std::max<uint32_t>(m_rate.m_delivered + in_flight, 1);
-        m_rateTrace(m_rate);
+        SetAppLimited(in_flight);
     }
 
     // m_appLimited will be reset once in GenerateSample, if it has to be.
@@ -156,6 +155,13 @@
 }
 
 void
+TcpRateLinux::SetAppLimited(uint32_t in_flight)
+{
+    m_rate.m_appLimited = std::max<uint32_t>(m_rate.m_delivered + in_flight, 1);
+    m_rateTrace(m_rate);
+}
+
+void
 TcpRateLinux::SkbDelivered(TcpTxItem* skb)
 {
     NS_LOG_FUNCTION(this << skb);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/tcp-rate-ops.h ns-3.45/src/internet/model/tcp-rate-ops.h
--- ns-3.44/src/internet/model/tcp-rate-ops.h	2025-03-09 16:55:49.407371300 -0700
+++ ns-3.45/src/internet/model/tcp-rate-ops.h	2025-06-01 20:34:45.330701400 -0700
@@ -113,6 +113,11 @@
      *
      */
     virtual const TcpRateConnection& GetConnectionRate() = 0;
+    /**
+     * @brief Updates the app-limited state based on in-flight data.
+     * @param in_flight In Flight size (in bytes)
+     */
+    virtual void SetAppLimited(uint32_t in_flight) = 0;
 
     /**
      * @brief Rate Sample structure
@@ -213,6 +218,12 @@
     }
 
     /**
+     * @brief Updates the app-limited state based on in-flight data.
+     * @param in_flight In Flight size (in bytes)
+     */
+    void SetAppLimited(uint32_t in_flight) override;
+
+    /**
      * TracedCallback signature for tcp rate update events.
      *
      * The callback will be fired each time the rate is updated.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/tcp-socket-base.cc ns-3.45/src/internet/model/tcp-socket-base.cc
--- ns-3.44/src/internet/model/tcp-socket-base.cc	2025-03-09 16:55:49.407371300 -0700
+++ ns-3.45/src/internet/model/tcp-socket-base.cc	2025-06-01 20:34:45.331701300 -0700
@@ -289,12 +289,6 @@
     return tid;
 }
 
-TypeId
-TcpSocketBase::GetInstanceTypeId() const
-{
-    return TcpSocketBase::GetTypeId();
-}
-
 TcpSocketBase::TcpSocketBase()
     : TcpSocket()
 {
@@ -435,10 +429,13 @@
     m_tcb->m_pacingRate = m_tcb->m_maxPacingRate;
     m_pacingTimer.SetFunction(&TcpSocketBase::NotifyPacingPerformed, this);
 
+    m_rateOps = CreateObject<TcpRateLinux>();
+
     if (sock.m_congestionControl)
     {
         m_congestionControl = sock.m_congestionControl->Fork();
         m_congestionControl->Init(m_tcb);
+        m_congestionControl->SetRateOps(m_rateOps);
     }
 
     if (sock.m_recoveryOps)
@@ -446,7 +443,6 @@
         m_recoveryOps = sock.m_recoveryOps->Fork();
     }
 
-    m_rateOps = CreateObject<TcpRateLinux>();
     if (m_tcb->m_sendEmptyPacketCallback.IsNull())
     {
         m_tcb->m_sendEmptyPacketCallback = MakeCallback(&TcpSocketBase::SendEmptyPacket, this);
@@ -2255,9 +2251,9 @@
 
                 m_tcb->m_cWndInfl = m_tcb->m_cWnd;
 
-                NS_LOG_LOGIC("Congestion control called: "
-                             << " cWnd: " << m_tcb->m_cWnd << " ssTh: " << m_tcb->m_ssThresh
-                             << " segsAcked: " << segsAcked);
+                NS_LOG_LOGIC("Congestion control called: cWnd: " << m_tcb->m_cWnd
+                                                                 << " ssTh: " << m_tcb->m_ssThresh
+                                                                 << " segsAcked: " << segsAcked);
 
                 NewAck(ackNumber, true);
             }
@@ -4663,6 +4659,7 @@
     NS_LOG_FUNCTION(this << algo);
     m_congestionControl = algo;
     m_congestionControl->Init(m_tcb);
+    m_congestionControl->SetRateOps(m_rateOps);
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/tcp-socket-base.h ns-3.45/src/internet/model/tcp-socket-base.h
--- ns-3.44/src/internet/model/tcp-socket-base.h	2025-03-09 16:55:49.411371200 -0700
+++ ns-3.45/src/internet/model/tcp-socket-base.h	2025-06-01 20:34:45.331701300 -0700
@@ -216,12 +216,6 @@
     static TypeId GetTypeId();
 
     /**
-     * @brief Get the instance TypeId
-     * @return the instance TypeId
-     */
-    TypeId GetInstanceTypeId() const override;
-
-    /**
      * @brief TcpGeneralTest friend class (for tests).
      * @relates TcpGeneralTest
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet/model/udp-socket-impl.h ns-3.45/src/internet/model/udp-socket-impl.h
--- ns-3.44/src/internet/model/udp-socket-impl.h	2025-03-09 16:55:49.411371200 -0700
+++ ns-3.45/src/internet/model/udp-socket-impl.h	2025-06-01 20:34:45.332701200 -0700
@@ -137,7 +137,7 @@
     int FinishBind();
 
     /**
-     * @brief Called by the L3 protocol when it received a packet to pass on to TCP.
+     * @brief Called by the L3 protocol when it received a packet to pass on to UDP.
      *
      * @param packet the incoming packet
      * @param header the packet's IPv4 header
@@ -150,7 +150,7 @@
                    Ptr<Ipv4Interface> incomingInterface);
 
     /**
-     * @brief Called by the L3 protocol when it received a packet to pass on to TCP.
+     * @brief Called by the L3 protocol when it received a packet to pass on to UDP.
      *
      * @param packet the incoming packet
      * @param header the packet's IPv6 header
@@ -208,7 +208,7 @@
     int DoSendTo(Ptr<Packet> p, Ipv6Address daddr, uint16_t dport);
 
     /**
-     * @brief Called by the L3 protocol when it received an ICMP packet to pass on to TCP.
+     * @brief Called by the L3 protocol when it received an ICMP packet to pass on to UDP.
      *
      * @param icmpSource the ICMP source address
      * @param icmpTtl the ICMP Time to Live
@@ -223,7 +223,7 @@
                      uint32_t icmpInfo);
 
     /**
-     * @brief Called by the L3 protocol when it received an ICMPv6 packet to pass on to TCP.
+     * @brief Called by the L3 protocol when it received an ICMPv6 packet to pass on to UDP.
      *
      * @param icmpSource the ICMP source address
      * @param icmpTtl the ICMP Time to Live
